Morph-M - Anomalie #42

pb bmpFileRead
12/01/2008 03:26 PM - Serge Koudoro

Status: Nouveau Start date:

Priority: Normal Due date:

Assignee: % Done: 50%
Category: old plone Bugs Estimated time: 0.00 hour
Target version:

Description

Description:

bmpFileRead echoue a la lecture de certain bmp en niveaux de gris (au moins ceux
créés par imagemagick) (et renvoie RES_OK).

Voila un petit programme pour mettre en evidence le probleme :

<CODE>

#include <morphee/imagelO/include/morpheelmagelO.hpp>

#include <morphee/image/include/morpheelmage.hpp>

int main(int argc, char *argvl]) {

morphee::lmagelnterface *img;

morphee::RES_C res_io;

std::string input_filename, output_filename;

morphee::iimagelO::initimagelO();

input_filename.assign(argv');

output_filename.assign(argv?);

res_io = morphee::imagelO::bmpFileRead(img, input_filename);

if ( (res_io!= morphee::RES_OK) || (img==NULL) ) {

std::cout << "Unable to read image" << std::endl;

return -1;

}
std::cout << "read image...OK" << std::endl;

if (morphee::imagelO::bmpFileWrite(img, output_filename)!=
morphee::RES_OK) {

std::cout << "Unable to write image" << std::endl;

return -1;

}
std::cout << "write image...Ok" << std::endl;
return O;

1
</CODE>

#2 13/02/2008 17:43 (Tibs)

Change: status: "pending" -> "accepted"”

Comment:

Bon le lecteur de BMP est vraiment moisi ca ¢ sur, mais s'il renvoie un res_ok
ca vaudra le coup de regarder si y'a pas une coquille dans le code.
Accessoirement: est-ce que ce serait pas l'ecriture de bmp qui foire ? A
verifier sans doute avec le bout de code propose...

#1 13/02/2008 14:23 (jo)

Change: topic: "™ -> "UI"

Change: solution: "™ -> "?"

Change: title: " -> "pb bmpFileRead"

Change: description: "" -> "bmpFileRead echoue a la lecture de certain bmp en niveaux de gris (au moins ceux créés par
imagemagick) (et renvoie RES_OK).

Voila un petit programme pour mettre en evidence le probleme :

<CODE>

#include <morphee/imagelO/include/morpheelmagelO.hpp>

#include <morphee/image/include/morpheelmage.hpp>
int main(int argc, char *argvl]) {
morphee::lmagelnterface *img;
morphee::RES_C res_io;

std::string input_filename, output_filename;

morphee: :imagelIO: :initImageIO();

input_filename.assign (argv[l]);
output_filename.assign(argv[2]);

res_io = morphee::imagelO: :bmpFileRead(img, input_filename) ;
if ( (res_io!= morphee::RES_OK) || (img==NULL) ) {
std::cout << "Unable to read image" << std::endl;
return -1;
}
std::cout << "read image...OK" << std::endl;
if (morphee::imagelO: :bmpFileWrite (img, output_filename) != morphee::RES_OK) {
std::cout << "Unable to write image" << std::endl;
return -1;
}
std::cout << "write image...Ok" << std::endl;
return 0;
}
&1t; /CODE&gL; "

History

#1 - 12/01/2008 03:30 PM - Ali HASSAINE
#4 comment 14/02/2008 11:58 (ali)

Comment:

Bon, il se trouve que le format bmp peut utiliser plusieurs types de
compression. La fonction bmpFileRead ne permet de lire que les bmp non
compresseés.

Dans ReadBMPHeader, on lit bien le type de compression utilisée
dans la variable

biCompression. Mais curieusement, le bitmap est lu dans bmpFileRead
a chaque

fois comme s'il n'était pas compressé. Et ce, indépendamment de la
valeur de la

variable biCompression.

En I'occurrence, dans I'image en question, la compression utilisée est
m_BI_RLES, et le fichier est lu comme s'il n'était pas compressé.

En attendant de développer (ou de copier de quelque part) le code
permettant de

lire les bmp avec les différents format de compression. Il faudrait

pour le

moment ajouter dans ReadBMPHeader, un test pour n'accepter que les
bmp non

compresseés:

if (biCompression!=m_BI_RGB) {
MORPHEE_REGISTER_ERROR(std::string("bmpFileRead can't read
compressed bmp

files"));

return RES_ERROR,;

}

#3 14/02/2008 10:01 (ali)

Upload: test.omp (Un fichier bmp qui présente ce probléme.)

#2 - 12/01/2008 03:35 PM - Serge Koudoro
- Category set to old plone Bugs
- Status changed from Nouveau to Résolu

- % Done changed from 0 to 100

#3 - 12/01/2008 03:36 PM - Serge Koudoro

- Status changed from Résolu to Nouveau
- % Done changed from 100 to 50

#4 - 06/22/2009 04:33 PM - Etienne Decenciére

Je ne sais pas si c'est lié, mais la lecture de I'image:

trunk/utilities/Images/Gray/antibiog.bmp

se passe mal chez moi...
